use std::ops::{Deref, DerefMut};

use glc::vector::Vector2f;
use specs::{Component, VecStorage};

pub struct Velocity(pub Vector2f);

impl Component for Velocity {
    type Storage = VecStorage<Self>;
}

impl Deref for Velocity {
    type Target = Vector2f;

    fn deref(&self) -> &Self::Target {
        &self.0
    }
}

impl DerefMut for Velocity {
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
